#include <stdio.h>
#include "mpg123.h"

struct mpg123_frame *mpg123_init_frame(struct mpg123_decoder *decoder) {
  struct mpg123_frame *fr;

  fr = (struct mpg123_frame *)malloc(sizeof(struct mpg123_frame));
  if (fr) fr->decoder = decoder;
  return fr;
}

void mpg123_decode_frame(struct mpg123_frame *fr,
                         unsigned char *inbuf,long inlen,
                         unsigned char *outbuf,long *outlen) {
  fr->inbuf = inbuf;
  fr->inlen = inlen;
  fr->outbuf = outbuf;
  getbits_init(&fr->gb);
  getbits_newbuf(&fr->gb,inbuf);
  mpg123_decode_header(fr,fr->inbuf);
  printf("have %d byte frame\n",fr->bpf);
  switch (fr->layer) {
    case MPG_LAYER_3: mpg123_do_layer3(fr);break;
//    case MPG_LAYER_2: mpg123_do_layer2(fr);break;
//    case MPG_LAYER_1: mpg123_do_layer1(fr);break;
    default: break;
  }
  *outlen = fr->outlen;
}
